CREATE OR REPLACE TRIGGER LOG_GER_AGENTETERCEFOR
AFTER UPDATE OR INSERT OR DELETE
ON AGENTETERCEFOR FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso, 
                  '2' - Alterao, 
                  '3' - Excluso*/

   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' Fornecedor=' || :OLD.CDFORNECED;
      END IF;

      IF :OLD.CDALMOXARIFE IS NOT NULL THEN
         V_DESC := V_DESC || ' Almoxarifado=' || :OLD.CDALMOXARIFE;
      END IF;

      IF :OLD.CDLOCALESTOQ IS NOT NULL THEN
         V_DESC := V_DESC || ' Localizao=' || :OLD.CDLOCALESTOQ;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.CDFORNECED;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDFILIAL,'!')     <> NVL(:NEW.CDFILIAL,'!'))     OR
            (NVL(:OLD.CDFORNECED,'!')   <> NVL(:NEW.CDFORNECED,'!'))    OR
            (NVL(:OLD.CDALMOXARIFE,'!') <> NVL(:NEW.CDALMOXARIFE,'!')) OR
            (NVL(:OLD.CDLOCALESTOQ,'!') <> NVL(:NEW.CDLOCALESTOQ,'!')) THEN

            IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
               V_DESC := V_DESC||' Filial='  || :NEW.CDFILIAL;
            END IF;

            IF :NEW.CDFORNECED <> :OLD.CDFORNECED THEN
               V_DESC := V_DESC||' Fornecedor='  || :NEW.CDFORNECED;
            END IF;

            IF NVL(:NEW.CDALMOXARIFE,'!') <> NVL(:OLD.CDALMOXARIFE,'!') THEN
               V_DESC := V_DESC||' Almoxarifado='  || :NEW.CDALMOXARIFE;
            END IF;

            IF  NVL(:NEW.CDLOCALESTOQ,'!') <> NVL(:OLD.CDLOCALESTOQ,'!') THEN
               V_DESC := V_DESC||' Localizao='||:NEW.CDLOCALESTOQ;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.CDFORNECED;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
            V_DESC := V_DESC||' Filial='  || :NEW.CDFILIAL;
         END IF;

         IF :NEW.CDFORNECED <> :OLD.CDFORNECED THEN
            V_DESC := V_DESC||' Fornecedor='  || :NEW.CDFORNECED;
         END IF;

         IF NVL(:NEW.CDALMOXARIFE,'!') <> NVL(:OLD.CDALMOXARIFE,'!') THEN
            V_DESC := V_DESC||' Almoxarifado='  || :NEW.CDALMOXARIFE;
         END IF;

         IF  NVL(:NEW.CDLOCALESTOQ,'!') <> NVL(:OLD.CDLOCALESTOQ,'!') THEN
            V_DESC := V_DESC||' Localizao='||:NEW.CDLOCALESTOQ;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.CDFORNECED;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER,
             CDFILLOGOPER)
         VALUES
            ('AGENTETERCEFOR',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER,
             V_CDFILLOGOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_AGENTETERCEFOR','5.85.xxx'); END;
/
